<!DOCTYPE html>

<html lang="en" data-content_root="../../../../">
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>sagace.core.storage.memory_storage &#8212; sagace 2025 documentation</title>
    <link rel="stylesheet" type="text/css" href="../../../../_static/pygments.css?v=5ecbeea2" />
    <link rel="stylesheet" type="text/css" href="../../../../_static/basic.css?v=b08954a9" />
    <link rel="stylesheet" type="text/css" href="../../../../_static/alabaster.css?v=27fed22d" />
    <script src="../../../../_static/documentation_options.js?v=cb975c41"></script>
    <script src="../../../../_static/doctools.js?v=9bcbadda"></script>
    <script src="../../../../_static/sphinx_highlight.js?v=dc90522c"></script>
    <link rel="index" title="Index" href="../../../../genindex.html" />
    <link rel="search" title="Search" href="../../../../search.html" />
   
  <link rel="stylesheet" href="../../../../_static/custom.css" type="text/css" />
  

  
  

  </head><body>
  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          

          <div class="body" role="main">
            
  <h1>Source code for sagace.core.storage.memory_storage</h1><div class="highlight"><pre>
<span></span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">--------------------------------------------------------------------------------------------------------------------</span>

<span class="sd">Descrição:</span>
<span class="sd">~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~</span>

<span class="sd">Este módulo define uma estrutura para gerenciamento de tokens de autenticação dentro do sistema SAGACE.</span>
<span class="sd">A classe `MemoryTokenStorage` implementa a interface `TokenStorage` para armazenar tokens temporariamente na memória,</span>
<span class="sd">permitindo acesso rápido sem necessidade de persistência em arquivos ou banco de dados.</span>

<span class="sd">Principais funcionalidades:</span>

<span class="sd">- Armazena tokens de autenticação apenas em memória.</span>
<span class="sd">- Recupera tokens armazenados durante a execução do programa.</span>
<span class="sd">- Implementa a interface `TokenStorage`, garantindo flexibilidade e substituição de implementação.</span>

<span class="sd">Princípios de Design Aplicados:</span>

<span class="sd">- **Single Responsibility Principle (SRP - SOLID)**: A classe tem a única responsabilidade de armazenar tokens em memória.</span>
<span class="sd">- **Open/Closed Principle (OCP - SOLID)**: `MemoryTokenStorage` pode ser estendida sem modificar seu código-fonte.</span>
<span class="sd">- **Dependency Inversion Principle (DIP - SOLID)**: `MemoryTokenStorage` depende da abstração `TokenStorage`, permitindo flexibilidade.</span>

<span class="sd">Classes:</span>

<span class="sd">- ``MemoryTokenStorage``: Implementação concreta de `TokenStorage` utilizando armazenamento em memória.</span>

<span class="sd">Exemplo de uso:</span>

<span class="sd">.. code-block:: python</span>

<span class="sd">    from sagace.core import Token, MemoryTokenStorage</span>

<span class="sd">    token_storage = MemoryTokenStorage()</span>
<span class="sd">    token = Token(</span>
<span class="sd">        base_url=&quot;https://api.sagace.online&quot;,</span>
<span class="sd">        access_token=&quot;abc123&quot;,</span>
<span class="sd">        application_name=&quot;Meu App&quot;,</span>
<span class="sd">        description=&quot;Token de acesso temporário.&quot;</span>
<span class="sd">    )</span>
<span class="sd">    token_storage.save_token(token)</span>
<span class="sd">    retrieved_token = token_storage.get_token()</span>
<span class="sd">    print(retrieved_token.get_auth_header())</span>

<span class="sd">Autor: Diego Yosiura</span>
<span class="sd">Última Atualização: 27/02/2025 16:24</span>
<span class="sd">Criado em: 27/02/2025 16:24</span>
<span class="sd">Copyright: (c) Ampere Consultoria Ltda</span>
<span class="sd">Projeto Original: sagace-v2-package</span>
<span class="sd">IDE: PyCharm</span>
<span class="sd">&quot;&quot;&quot;</span>

<span class="kn">from</span><span class="w"> </span><span class="nn">..</span><span class="w"> </span><span class="kn">import</span> <span class="n">Token</span>
<span class="kn">from</span><span class="w"> </span><span class="nn">..</span><span class="w"> </span><span class="kn">import</span> <span class="n">TokenStorage</span>


<div class="viewcode-block" id="MemoryTokenStorage">
<a class="viewcode-back" href="../../../../sagace.core.storage.html#sagace.core.storage.memory_storage.MemoryTokenStorage">[docs]</a>
<span class="k">class</span><span class="w"> </span><span class="nc">MemoryTokenStorage</span><span class="p">(</span><span class="n">TokenStorage</span><span class="p">):</span>
<span class="w">    </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Implementação de `TokenStorage` para armazenamento temporário de tokens na memória.</span>

<span class="sd">    Esta classe permite armazenar tokens de autenticação em memória para acesso rápido,</span>
<span class="sd">    garantindo que os tokens sejam descartados ao final da execução do programa.</span>

<span class="sd">    Princípios aplicados:</span>

<span class="sd">    - **Single Responsibility Principle (S - SOLID)**: Responsável apenas por armazenar e recuperar tokens na memória.</span>
<span class="sd">    - **Dependency Inversion Principle (D - SOLID)**: Depende da abstração `TokenStorage`, garantindo desacoplamento.</span>
<span class="sd">    &quot;&quot;&quot;</span>

    <span class="k">def</span><span class="w"> </span><span class="fm">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
<span class="w">        </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        Inicializa a classe `MemoryTokenStorage`, criando uma variável interna para armazenar o token.</span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">_token</span> <span class="o">=</span> <span class="kc">None</span>

<div class="viewcode-block" id="MemoryTokenStorage.save_token">
<a class="viewcode-back" href="../../../../sagace.core.storage.html#sagace.core.storage.memory_storage.MemoryTokenStorage.save_token">[docs]</a>
    <span class="k">def</span><span class="w"> </span><span class="nf">save_token</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">token</span><span class="p">:</span> <span class="n">Token</span><span class="p">):</span>
<span class="w">        </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        Armazena o token na memória.</span>

<span class="sd">        :param token: Instância do token a ser armazenado.</span>
<span class="sd">        :type token: Token</span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">_token</span> <span class="o">=</span> <span class="n">token</span></div>


<div class="viewcode-block" id="MemoryTokenStorage.get_token">
<a class="viewcode-back" href="../../../../sagace.core.storage.html#sagace.core.storage.memory_storage.MemoryTokenStorage.get_token">[docs]</a>
    <span class="k">def</span><span class="w"> </span><span class="nf">get_token</span><span class="p">(</span><span class="bp">self</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="n">Token</span><span class="p">:</span>
<span class="w">        </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        Recupera o token armazenado na memória.</span>

<span class="sd">        :return: Instância do token armazenado.</span>
<span class="sd">        :rtype: Token</span>
<span class="sd">        :raises ValueError: Se o token não estiver armazenado na memória.</span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="k">if</span> <span class="ow">not</span> <span class="bp">self</span><span class="o">.</span><span class="n">_token</span><span class="p">:</span>
            <span class="k">raise</span> <span class="ne">ValueError</span><span class="p">(</span><span class="s2">&quot;Token not found in memory.&quot;</span><span class="p">)</span>
        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">_token</span></div>
</div>

</pre></div>

          </div>
          
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="Main">
        <div class="sphinxsidebarwrapper">
<h1 class="logo"><a href="../../../../index.html">sagace</a></h1>









<search id="searchbox" style="display: none" role="search">
    <div class="searchformwrapper">
    <form class="search" action="../../../../search.html" method="get">
      <input type="text" name="q" aria-labelledby="searchlabel" autocomplete="off" autocorrect="off" autocapitalize="off" spellcheck="false" placeholder="Search"/>
      <input type="submit" value="Go" />
    </form>
    </div>
</search>
<script>document.getElementById('searchbox').style.display = "block"</script><h3>Navigation</h3>
<p class="caption" role="heading"><span class="caption-text">Conteúdo:</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../../../modules.html">sagace</a></li>
</ul>

<div class="relations">
<h3>Related Topics</h3>
<ul>
  <li><a href="../../../../index.html">Documentation overview</a><ul>
  <li><a href="../../../index.html">Module code</a><ul>
  </ul></li>
  </ul></li>
</ul>
</div>








        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="footer">
      &#169;2025, Ampere Consultoria.
      
      |
      Powered by <a href="https://www.sphinx-doc.org/">Sphinx 8.2.1</a>
      &amp; <a href="https://alabaster.readthedocs.io">Alabaster 1.0.0</a>
      
    </div>

    

    
  </body>
</html>